Show notice on project's overview page when the project is public
2021-04-06 18:03 - Go MAEDA
Assignee: % Done: 0%
Target version:

Resolution:

Description

| suggest that when a project is set to public, the project overview page should show that the project is public and a message
describes its impact. The message shown is the same as the one shown in the project settings page improved in #27009.

Although setting the project public sometimes may be dangerous, you cannot know if the project is public unless seeing the project's
settings page.

It will be easier to notice if the project is set as public by showing the fact in the Members box. Since the Members box shows users
who have access to the project, | think it is consistent to show if the project is visible by non-members or anonymous users.

public-status-in-members-box.png

Related issues:
Related to Redmine - Patch #27009: Clarify consequences of disabling the logi... Closed

History

#1 - 2021-04-06 18:05 - Go MAEDA

The following code is a sample implementation.

diff --git a/app/views/projects/_members_box.html.erb b/app/views/projects/_members_box.html.erb
index €915ab910..72d7fb97b 100644
—-—— a/app/views/projects/_members_box.html.erb
+++ b/app/views/projects/_members_box.html.erb
@@ -4,5 +4,10 Q@

<% @principals_by_role.keys.sort.each do |role| %>

<p><span class="label"><%= role %>:</span> <%= @principals_by_role[role].sort.collect{|p| link_to_user

p}.join(", ").html_safe %></p>

<% end %>

+ <% 1f @project.is_public %>
+ <hr>
+ <p span class="label"><%= 1(:field_is_public) $%$>:</span> <%= 1l (:general_text_Yes) %>
+ <em class="info"><%= Setting.login_required? ? 1l(:text_project_is_public_non_member) : 1l (:text_project_
is_public_anonymous) %></em>
+ <% end —%>
</div>
<% end %>
</diff>

#2 - 2021-04-06 18:07 - Go MAEDA
- Related to Patch #27009: Clarify consequences of disabling the login_required setting added

#3 - 2021-04-07 01:57 - Mizuki ISHIKAWA
+1

Private information may be leaked if the settings are mistakenly made public when creating a project.
| think this feature is needed to quickly notice that the project is open to the public.

#4 - 2021-04-07 02:46 - Kevin Fischer

+1

On a somewhat related note:
About 1 month ago we also implemented and posted a patch for a new permission for publishing projects in response to #9029 . Maybe this could be
considered for Redmine 5.0 ? It would surely help to counter the security concerns regarding public projects....

#5 - 2021-05-03 23:13 - Marius BALTEANU

Maybe we should add a Public badge next to Overview title as we have for issues and versions.

#6 - 2021-05-08 09:27 - Mizuki ISHIKAWA

- File 0001-Add-test.patch added

- File 0002-Add-project-public-badge.patch added
- File screenshot.png added

| have attached a patch that adds a test to #35044#note-1. => 0001-Add-test.patch

| also made 0002-Add-project-public-badge.patch to add a badge based on the opinion of #35044#note-5. Please let me know if you need to separate
the issue.
screenshot.png
These patches were developed with Ko Nagase and Akihiro MATOBA .
#7 - 2021-05-08 10:20 - Go MAEDA
Mizuki ISHIKAWA wrote:

| have attached a patch that adds a test to #35044#note-1. => 0001-Add-test.patch

| also made 0002-Add-project-public-badge.patch to add a badge based on the opinion of #35044#note-5. Please let me know if you need to
separate the issue.
screenshot.png

Thank you for the patch but | think it is better to post as a new issue because the feature implemented by the patch is very different from the original
proposal.

In addition, | suggest the following improvements:

e The badge is for a single project, the noun should be singular ("projects" -> "project")

e Maybe "public project" is too long. | think "public" is enough

* The color #d22 is too prominent. Also, the red color gives a wrong impression that the public project itself is dangerous and bad. Making a
project public is not dangerous. The danger is that you will set it up incorrectly

#8 - 2021-05-10 02:41 - Mizuki ISHIKAWA
Go MAEDA wrote:

Thank you for the patch but | think it is better to post as a new issue because the feature implemented by the patch is very different from the
original proposal.

In addition, | suggest the following improvements:

e The badge is for a single project, the noun should be singular ("projects" -> "project")

¢ Maybe "public project” is too long. | think "public" is enough

e The color #d22 is too prominent. Also, the red color gives a wrong impression that the public project itself is dangerous and bad. Making a
project public is not dangerous. The danger is that you will set it up incorrectly

Thank you for your feedback.
I made a new issue #35221 and attached a new patch that was modified based on the feedback.

#9 - 2021-05-11 07:47 - Marius BALTEANU
We should show this info only once on this page and the members box is not the best option because the project visibility is an attribute of the project,
not of the members. Also, in projects with multiple members or news, the information will be visibile only after more or less scroll.

From my point of view, having the bagde with a title attribute should be enough. If you don't like this approach, then we should show this info in the
project attributes box (top left).

#10 - 2021-05-11 07:54 - Marius BALTEANU

One more thing, project content visibility depends on the rights configured for anonymous/non member roles, maybe the message should be more
specific because the current one says that the content is publicly available. Also, in an era of SaaS/cloud applications, we should avoid using the word
network. .
#11 - 2021-05-11 08:19 - Go MAEDA

What | wanted to show in the members box is public not whether the project is public or not, but anonymous users and nonmembers can access the

project.

I think it would be good to discuss how to indicate that a project is public, based on the patch in #35221.

#12 - 2021-05-11 08:26 - Marius BALTEANU
Go MAEDA wrote:

What | wanted to show in the members box is public not whether the project is public or not, but anonymous users and nonmembers can access

the project.

| understand now and | think it's a valuable information.

| think it would be good to discuss how to indicate that a project is public, based on the patch in #35221.

Ok, | will add my proposals there in the following days.

Files

public-status-in-members-box.png 44.2 KB 2021-04-06 Go MAEDA
0001-Add-test.patch 2.65 KB 2021-05-08 Mizuki ISHIKAWA
0002-Add-project-public-badge.patch 2.6 KB 2021-05-08 Mizuki ISHIKAWA
screenshot.png 300 KB 2021-05-08 Mizuki ISHIKAWA
